// GetUniqueId.cpp : Defines the entry point for the console application.
//

#include "D:\Technical\Toradex\NVIDIA_Website\CE7_Source\nvap_ce7_harmony_source_release_5998895.tar\PLATFORM\nvap\prebuilt\inc\nvrm_init.h"
#include "D:\Technical\Toradex\NVIDIA_Website\CE7_Source\nvap_ce7_harmony_source_release_5998895.tar\PLATFORM\nvap\src\drivers\nvrm\nvrmkernel\core\ap20\ap20rm_misc_private.h"
#include "nvrm_structure.h"
#include <windows.h>

typedef NvError (CALLBACK* LPFNDLLFUNC1)(NvRmDeviceHandle hDevHandle, NvU32 IdSize, void* pId);
typedef NvError (CALLBACK* LPFNDLLFUNC2)(NvRmDeviceHandle *pHandle, NvU32 DeviceId);
typedef NvError (CALLBACK* LPFNDLLFUNC3)(NvRmDeviceHandle hDevice );
void NvRmClose( 
			   NvRmDeviceHandle hDevice );
HINSTANCE hDLL;               // Handle to DLL
LPFNDLLFUNC1 lpfnDllFunc1;    // Function pointer
LPFNDLLFUNC2 lpfnDllFunc2;    // Function pointer
LPFNDLLFUNC3 lpfnDllFunc3;    // Function pointer
NvU64 chipId;

unsigned long long getcolibritxxuniqueid()
{
	UINT  uReturnVal;
	void* pId = (void *)&chipId;
	NvU32 IdSize = sizeof(NvU64);
	NvRmDeviceHandle hDevHandle = (NvRmDeviceHandle)malloc(sizeof(NvRmDeviceRec));
	hDLL = LoadLibrary(L"libnvrm");
	if (hDLL != NULL)
	{
		lpfnDllFunc1 = (LPFNDLLFUNC1)GetProcAddress(hDLL, L"NvRmQueryChipUniqueId");
		lpfnDllFunc2 = (LPFNDLLFUNC2)GetProcAddress(hDLL, L"NvRmOpen");
		lpfnDllFunc3 = (LPFNDLLFUNC3)GetProcAddress(hDLL, L"NvRmClose");
		if (!lpfnDllFunc1)
		{
			// handle the error
			FreeLibrary(hDLL);
			return 0;
		}
		else
		{
			uReturnVal = lpfnDllFunc2(&hDevHandle, 0);
			uReturnVal = lpfnDllFunc1(hDevHandle, IdSize, pId);
			uReturnVal = lpfnDllFunc3(hDevHandle);
		}
		return chipId;
	}
}